import ES2016Operations = require('es-abstract/operations/2016');
import ES2017 = require('es-abstract/es2017');
import ES2017Operations = require('es-abstract/operations/2017');

// Attempting to use `$ExpectType` in this file leads to intermittent dtslint failures
import { expectType } from '../index.test';

declare function keyof<T>(target: T): keyof T;

expectType<ExpectedKeys>(keyof(ES2017Operations));
expectType<keyof ES2017Operations>(ExpectedKeys);

expectType<AddedKeys>(AddedKeysActual);
expectType<typeof AddedKeysActual>(AddedKeys);

expectType<AllAddedKeys>(AllAddedKeysActual);
expectType<typeof AllAddedKeysActual>(AllAddedKeys);

expectType<RemovedKeys>(RemovedKeysActual);
expectType<typeof RemovedKeysActual>(RemovedKeys);

declare const ExpectedKeys: ExpectedKeys;

declare const AddedKeysActual: Exclude<keyof ES2017Operations, keyof ES2016Operations | keyof ES2017>;
export declare const AddedKeys: AddedKeys;

declare const AllAddedKeysActual: Exclude<keyof ES2017Operations, keyof ES2016Operations>;
export declare const AllAddedKeys: AddedKeys;

declare const RemovedKeysActual: Exclude<keyof ES2016Operations, keyof ES2017Operations>;
export declare const RemovedKeys: RemovedKeys;

// ## Long types:
//#region RemovedKeys
export type RemovedKeys = 'EnumerableOwnNames' | 'IterableToArrayLike' | 'NextJob';
//#endregion

//#region AddedKeys
export type AllAddedKeys = AddedKeys | 'EnumerableOwnProperties' | 'IterableToList' | 'ToIndex';

export type AddedKeys =
    | 'AddWaiter'
    | 'agent-order'
    | 'AgentCanSuspend'
    | 'AgentSignifier'
    | 'AllocateSharedArrayBuffer'
    | 'AsyncFunctionAwait'
    | 'AsyncFunctionCreate'
    | 'AsyncFunctionStart'
    | 'AtomicLoad'
    | 'AtomicReadModifyWrite'
    | 'ComposeWriteEventBytes'
    | 'CreateSharedByteDataBlock'
    | 'EnterCriticalSection'
    | 'EventSet'
    | 'GetBase'
    | 'GetModifySetValueInBuffer'
    | 'GetReferencedName'
    | 'GetWaiterList'
    | 'happens-before'
    | 'HasPrimitiveBase'
    | 'host-synchronizes-with'
    | 'HostEnsureCanCompileStrings'
    | 'HostEventSet'
    | 'IsPropertyReference'
    | 'IsSharedArrayBuffer'
    | 'IsStrictReference'
    | 'IsSuperReference'
    | 'IsUnresolvableReference'
    | 'LeaveCriticalSection'
    | 'memory-order'
    | 'NumberToRawBytes'
    | 'OrdinaryToPrimitive'
    | 'RawBytesToNumber'
    | 'reads-bytes-from'
    | 'reads-from'
    | 'RemoveWaiter'
    | 'RemoveWaiters'
    | 'RunJobs'
    | 'SetImmutablePrototype'
    | 'SharedDataBlockEventSet'
    | 'StringGetOwnProperty'
    | 'Suspend'
    | 'synchronizes-with'
    | 'ValidateAtomicAccess'
    | 'ValidateSharedIntegerTypedArray'
    | 'ValueOfReadEvent'
    | 'WakeWaiter'
    | 'WordCharacters';
//#endregion

//#region ExpectedKeys
type ExpectedKeys =
    | 'IsPropertyDescriptor'
    | 'abs'
    | 'Abstract Equality Comparison'
    | 'Abstract Relational Comparison'
    | 'AddRestrictedFunctionProperties'
    | 'AddWaiter'
    | 'AdvanceStringIndex'
    | 'agent-order'
    | 'AgentCanSuspend'
    | 'AgentSignifier'
    | 'AllocateArrayBuffer'
    | 'AllocateSharedArrayBuffer'
    | 'AllocateTypedArray'
    | 'AllocateTypedArrayBuffer'
    | 'ArrayCreate'
    | 'ArraySetLength'
    | 'ArraySpeciesCreate'
    | 'AsyncFunctionAwait'
    | 'AsyncFunctionCreate'
    | 'AsyncFunctionStart'
    | 'AtomicLoad'
    | 'AtomicReadModifyWrite'
    | 'BlockDeclarationInstantiation'
    | 'BoundFunctionCreate'
    | 'Call'
    | 'Canonicalize'
    | 'CanonicalNumericIndexString'
    | 'CharacterRange'
    | 'CharacterRangeOrUnion'
    | 'CharacterSetMatcher'
    | 'CloneArrayBuffer'
    | 'CompletePropertyDescriptor'
    | 'Completion'
    | 'ComposeWriteEventBytes'
    | 'Construct'
    | 'CopyDataBlockBytes'
    | 'CreateArrayFromList'
    | 'CreateArrayIterator'
    | 'CreateBuiltinFunction'
    | 'CreateByteDataBlock'
    | 'CreateDataProperty'
    | 'CreateDataPropertyOrThrow'
    | 'CreateDynamicFunction'
    | 'CreateHTML'
    | 'CreateIntrinsics'
    | 'CreateIterResultObject'
    | 'CreateListFromArrayLike'
    | 'CreateListIterator'
    | 'CreateMapIterator'
    | 'CreateMappedArgumentsObject'
    | 'CreateMethodProperty'
    | 'CreatePerIterationEnvironment'
    | 'CreateRealm'
    | 'CreateResolvingFunctions'
    | 'CreateSetIterator'
    | 'CreateSharedByteDataBlock'
    | 'CreateStringIterator'
    | 'CreateUnmappedArgumentsObject'
    | 'DateFromTime'
    | 'Day'
    | 'DayFromYear'
    | 'DaysInYear'
    | 'DayWithinYear'
    | 'Decode'
    | 'DefinePropertyOrThrow'
    | 'DeletePropertyOrThrow'
    | 'DetachArrayBuffer'
    | 'Encode'
    | 'EnqueueJob'
    | 'EnterCriticalSection'
    | 'EnumerableOwnProperties'
    | 'EnumerateObjectProperties'
    | 'EscapeRegExpPattern'
    | 'EvalDeclarationInstantiation'
    | 'EvaluateCall'
    | 'EvaluateDirectCall'
    | 'EvaluateNew'
    | 'EventSet'
    | 'floor'
    | 'ForBodyEvaluation'
    | 'ForIn/OfBodyEvaluation'
    | 'ForIn/OfHeadEvaluation'
    | 'FromPropertyDescriptor'
    | 'FulfillPromise'
    | 'FunctionAllocate'
    | 'FunctionCreate'
    | 'FunctionDeclarationInstantiation'
    | 'FunctionInitialize'
    | 'GeneratorFunctionCreate'
    | 'GeneratorResume'
    | 'GeneratorResumeAbrupt'
    | 'GeneratorStart'
    | 'GeneratorValidate'
    | 'GeneratorYield'
    | 'Get'
    | 'GetActiveScriptOrModule'
    | 'GetBase'
    | 'GetFunctionRealm'
    | 'GetGlobalObject'
    | 'GetIdentifierReference'
    | 'GetIterator'
    | 'GetMethod'
    | 'GetModifySetValueInBuffer'
    | 'GetModuleNamespace'
    | 'GetNewTarget'
    | 'GetOwnPropertyKeys'
    | 'GetPrototypeFromConstructor'
    | 'GetReferencedName'
    | 'GetSubstitution'
    | 'GetSuperConstructor'
    | 'GetTemplateObject'
    | 'GetThisEnvironment'
    | 'GetThisValue'
    | 'GetV'
    | 'GetValue'
    | 'GetValueFromBuffer'
    | 'GetViewValue'
    | 'GetWaiterList'
    | 'GlobalDeclarationInstantiation'
    | 'happens-before'
    | 'HasOwnProperty'
    | 'HasPrimitiveBase'
    | 'HasProperty'
    | 'host-synchronizes-with'
    | 'HostEnsureCanCompileStrings'
    | 'HostEventSet'
    | 'HostPromiseRejectionTracker'
    | 'HostReportErrors'
    | 'HostResolveImportedModule'
    | 'HourFromTime'
    | 'IfAbruptRejectPromise'
    | 'ImportedLocalNames'
    | 'InitializeBoundName'
    | 'InitializeHostDefinedRealm'
    | 'InitializeReferencedBinding'
    | 'InLeapYear'
    | 'InstanceofOperator'
    | 'IntegerIndexedElementGet'
    | 'IntegerIndexedElementSet'
    | 'IntegerIndexedObjectCreate'
    | 'InternalizeJSONProperty'
    | 'Invoke'
    | 'IsAccessorDescriptor'
    | 'IsAnonymousFunctionDefinition'
    | 'IsArray'
    | 'IsCallable'
    | 'IsCompatiblePropertyDescriptor'
    | 'IsConcatSpreadable'
    | 'IsConstructor'
    | 'IsDataDescriptor'
    | 'IsDetachedBuffer'
    | 'IsExtensible'
    | 'IsGenericDescriptor'
    | 'IsInTailPosition'
    | 'IsInteger'
    | 'IsLabelledFunction'
    | 'IsPromise'
    | 'IsPropertyKey'
    | 'IsPropertyReference'
    | 'IsRegExp'
    | 'IsSharedArrayBuffer'
    | 'IsStrictReference'
    | 'IsSuperReference'
    | 'IsUnresolvableReference'
    | 'IsWordChar'
    | 'IterableToList'
    | 'IteratorClose'
    | 'IteratorComplete'
    | 'IteratorNext'
    | 'IteratorStep'
    | 'IteratorValue'
    | 'LeaveCriticalSection'
    | 'LocalTime'
    | 'LoopContinues'
    | 'MakeArgGetter'
    | 'MakeArgSetter'
    | 'MakeClassConstructor'
    | 'MakeConstructor'
    | 'MakeDate'
    | 'MakeDay'
    | 'MakeMethod'
    | 'MakeSuperPropertyReference'
    | 'MakeTime'
    | 'max'
    | 'memory-order'
    | 'min'
    | 'MinFromTime'
    | 'ModuleNamespaceCreate'
    | 'modulo'
    | 'MonthFromTime'
    | 'msFromTime'
    | 'NewDeclarativeEnvironment'
    | 'NewFunctionEnvironment'
    | 'NewGlobalEnvironment'
    | 'NewModuleEnvironment'
    | 'NewObjectEnvironment'
    | 'NewPromiseCapability'
    | 'NormalCompletion'
    | 'NumberToRawBytes'
    | 'ObjectCreate'
    | 'ObjectDefineProperties'
    | 'OrdinaryCallBindThis'
    | 'OrdinaryCallEvaluateBody'
    | 'OrdinaryCreateFromConstructor'
    | 'OrdinaryDefineOwnProperty'
    | 'OrdinaryDelete'
    | 'OrdinaryGet'
    | 'OrdinaryGetOwnProperty'
    | 'OrdinaryGetPrototypeOf'
    | 'OrdinaryHasInstance'
    | 'OrdinaryHasProperty'
    | 'OrdinaryIsExtensible'
    | 'OrdinaryOwnPropertyKeys'
    | 'OrdinaryPreventExtensions'
    | 'OrdinarySet'
    | 'OrdinarySetPrototypeOf'
    | 'OrdinaryToPrimitive'
    | 'ParseModule'
    | 'ParseScript'
    | 'PerformEval'
    | 'PerformPromiseAll'
    | 'PerformPromiseRace'
    | 'PerformPromiseThen'
    | 'PrepareForOrdinaryCall'
    | 'PrepareForTailCall'
    | 'PromiseReactionJob'
    | 'PromiseResolveThenableJob'
    | 'ProxyCreate'
    | 'PutValue'
    | 'QuoteJSONString'
    | 'RawBytesToNumber'
    | 'reads-bytes-from'
    | 'reads-from'
    | 'RegExpAlloc'
    | 'RegExpBuiltinExec'
    | 'RegExpCreate'
    | 'RegExpExec'
    | 'RegExpInitialize'
    | 'RejectPromise'
    | 'RemoveWaiter'
    | 'RemoveWaiters'
    | 'RepeatMatcher'
    | 'RequireObjectCoercible'
    | 'ResolveBinding'
    | 'ResolveThisBinding'
    | 'ReturnIfAbrupt'
    | 'RunJobs'
    | 'SameValue'
    | 'SameValueNonNumber'
    | 'SameValueZero'
    | 'ScriptEvaluation'
    | 'ScriptEvaluationJob'
    | 'SecFromTime'
    | 'SerializeJSONArray'
    | 'SerializeJSONObject'
    | 'SerializeJSONProperty'
    | 'Set'
    | 'SetDefaultGlobalBindings'
    | 'SetFunctionName'
    | 'SetImmutablePrototype'
    | 'SetIntegrityLevel'
    | 'SetRealmGlobalObject'
    | 'SetValueInBuffer'
    | 'SetViewValue'
    | 'SharedDataBlockEventSet'
    | 'SortCompare'
    | 'SpeciesConstructor'
    | 'SplitMatch'
    | 'Strict Equality Comparison'
    | 'StringCreate'
    | 'StringGetOwnProperty'
    | 'Suspend'
    | 'SymbolDescriptiveString'
    | 'synchronizes-with'
    | 'TestIntegrityLevel'
    | 'thisBooleanValue'
    | 'thisNumberValue'
    | 'thisStringValue'
    | 'thisTimeValue'
    | 'TimeClip'
    | 'TimeFromYear'
    | 'TimeWithinDay'
    | 'ToBoolean'
    | 'ToDateString'
    | 'ToIndex'
    | 'ToInt16'
    | 'ToInt32'
    | 'ToInt8'
    | 'ToInteger'
    | 'ToLength'
    | 'ToNumber'
    | 'ToObject'
    | 'TopLevelModuleEvaluationJob'
    | 'ToPrimitive'
    | 'ToPropertyDescriptor'
    | 'ToPropertyKey'
    | 'ToString'
    | 'ToString Applied to the Number Type'
    | 'ToUint16'
    | 'ToUint32'
    | 'ToUint8'
    | 'ToUint8Clamp'
    | 'TriggerPromiseReactions'
    | 'Type'
    | 'TypedArrayCreate'
    | 'TypedArraySpeciesCreate'
    | 'UpdateEmpty'
    | 'UTC'
    | 'UTF16Decode'
    | 'UTF16Encoding'
    | 'ValidateAndApplyPropertyDescriptor'
    | 'ValidateAtomicAccess'
    | 'ValidateSharedIntegerTypedArray'
    | 'ValidateTypedArray'
    | 'ValueOfReadEvent'
    | 'WakeWaiter'
    | 'WeekDay'
    | 'WordCharacters'
    | 'YearFromTime';
//#endregion
